document.addEventListener("DOMContentLoaded", function(event) { 
   // hide all but latest watu-question DIVs. This is needed in case we come from in_progress   
   if(typeof WatuPRO.exam_id == 'undefined') {
	   WatuPRO.exam_id = jQuery('#watuPROExamID').val();
   }
	jQuery('#watuPROButtons' + WatuPRO.exam_id).hide();
	jQuery('#quiz-' + WatuPRO.exam_id + ' .watupro-paginator-wrap').hide();	
	jQuery('#quiz-' + WatuPRO.exam_id + ' .watupro-qnum-info').hide();
	jQuery('#quiz-' + WatuPRO.exam_id + ' .watupro-qnum').hide();
	
	var par = jQuery('#watuPROButtons' + WatuPRO.exam_id).parent();
	jQuery(par).append('<div style="width:100%;clear:both;" id="beforeWchainedButon'+WatuPRO.exam_id+'">&nbsp;</div><div class="watupro-buttons flex"><input id="chainActButton'
		+ WatuPRO.exam_id + '" type="button" class="watupro-submit-button" value="' + wchained_i18n.button_text + '" onclick="wchainedLogic.goon(' + WatuPRO.exam_id + ');return false;"></div>');
		
	jQuery('#chainActButton' + WatuPRO.exam_id).show(); // make sure the action button is shown in case we have hidden it due to autocontinue	
	
	wchainedLogic = {};
	wchainedLogic.points = 0; // initialize the points as 0
	wchainedLogic.questions_answered = 0;
	
	// make sure the first quesiton won't be shown in case we are loading in progress
	jQuery('#question-1').attr("id","chained-question-1");
	// we always have to make sure the latest is shown
	jQuery('div.watu-question').slice(-1).show();
	
	// is the currently visible question a radio and we have auto-go to next? then hide "go ahead"
	if(typeof(WatuPROSettings[WatuPRO.exam_id]) !== 'undefined' && WatuPROSettings[WatuPRO.exam_id].singleChoiceAction == 'next' 
		&& jQuery('.answerTypeCnt1').val() == 'radio') {		
		jQuery('#chainActButton' + WatuPRO.exam_id).hide();	
	}
	
	wchainedLogic.goon = function(quizID) {		
		jQuery('#chainActButton' + WatuPRO.exam_id).attr('disabled', true);
		jQuery('.watupro-exam-description').hide();
		
		// make sure there is answer selected
		//var qID = jQuery('#quiz-' + quizID + ' input[name="question_id[]"]').last().val();
		// this is working because the first input in the question is actually always the field containing the hidden ID
		var qID = jQuery("div.watu-question").not(":hidden").find('input').first().val();	
		//console.log(qID);	
		var qType = jQuery('#answerType' + qID).val();
		var chkClass = 'chained-quiz-' + qType;
		
		// see how to check for required question here
		if(!WatuPRO.isAnswered(qID) && (jQuery('.watupro-required-'+qID).length || wchained_i18n.required_from_watupro != 1)) {
			alert(wchained_i18n.please_answer);
			jQuery('#chainActButton' + WatuPRO.exam_id).removeAttr('disabled');
			return false;
		}
		
		// submit the answer by ajax
		data = jQuery('#quiz-'+quizID).serialize();
		data += '&action=wchained_ajax';
		data += '&wchained_action=answer';
		data += '&question_id=' + qID;
		this.questions_answered++;		
		data += '&total_questions=' + this.questions_answered;
		
		if(WatuPRO.store_progress) data += '&store_progress=1';
		

		//console.log(data);		
		jQuery.post(wchained_i18n.ajax_url, data, function(msg) {
			  parts = msg.split("|WCHAINED_LOGIC|");
			 
			  if(jQuery('body').scrollTop() > 250) {				
					jQuery('html, body').animate({
				   		scrollTop: jQuery('#quiz-'+quizID).offset().top -100
				   }, 500);   
			  }		  
			  
			  if(parts[0] == 'next') {		  	
			  	   // show next question
			  		jQuery('#quiz-'+quizID + ' .watu-question').hide();		  		
			  		
			  		// if the question was shown before we will have more than one element with the same ID.
			  		// we have to remove all but the first one
					jQuery('#wchained-question-' + parts[2]).remove();
							
			  		jQuery('#quiz-'+quizID).prepend(parts[1]);			  		
			  		jQuery('#wchained-question-' + parts[2]).show();
			  				
			  		// add to the hidden field with serialized questions
			  		var wtpQuestions = jQuery('#quiz-' + quizID + ' input[name=watupro_questions]').val();
			  		// but add only if it doesn't already exist
			  		var curQuestionIDs = [];
			  		var wtpParts = wtpQuestions.split(" | ");
			  		if(wtpParts.indexOf(parts[3]) == -1) {									  		
			  			wtpQuestions += ' | ' + parts[3];
			  			jQuery('#quiz-' + quizID + ' input[name=watupro_questions]').val(wtpQuestions);
			  		}		  	
			  		
			  		// add the question ID to WatuPRO.qArr;			  		
			  		var newIndex = WatuPRO.qArr.length;
			  		WatuPRO.qArr[newIndex] = parts[2]; // question ID
			  		
			  		if(jQuery().flip) jQuery(".watupro_flashcard:not(.processed)").flip({trigger: 'manual'});
			  		if (typeof MathJax != 'undefined') {
			   		if(typeof MathJax.Hub != 'undefined') MathJax.Hub.Queue(["Typeset",MathJax.Hub, 'wchained-question-' + parts[2]]);
			   		MathJax.typeset();
			   	}
			  		
			  		// back to top	only if the page is scrolled a bit already	
					if(!WatuPRO.dontScroll && jQuery(document).scrollTop() > 250) {
						jQuery('html, body').animate({
					   		scrollTop: jQuery('#watupro_quiz').offset().top -100
					   }, 100);   
					}   
			  		
			  		jQuery('.watupro-qnum').hide();
			  		jQuery('#chainActButton' + WatuPRO.exam_id).removeAttr('disabled');
			  		
			  		// handle the WatuPRO advanced setting for automatically going to next question	
					if(typeof(WatuPROSettings[WatuPRO.exam_id]) !== 'undefined' && WatuPROSettings[WatuPRO.exam_id].singleChoiceAction == 'next') {			
						jQuery('#quiz-' + WatuPRO.exam_id + ' input[type=radio].answer').click(function(e){
							wchainedLogic.goon(WatuPRO.exam_id);
						}); // end click event
					} // end handling automated going to next question
					
					// again hide or show the action button for the next question depending on whether we are in auto-continue mode and the next is radio
					if(typeof(WatuPROSettings[WatuPRO.exam_id]) !== 'undefined' && WatuPROSettings[WatuPRO.exam_id].singleChoiceAction == 'next' 
						&& jQuery('.answerTypeCnt1').val() == 'radio') {		
						jQuery('#chainActButton' + WatuPRO.exam_id).hide();	
					}
					else jQuery('#chainActButton' + WatuPRO.exam_id).show(); // make sure the action button is shown in case we have hidden it due to autocontinue	
			  }
			  else {
			  	  if(!WatuPRO.validateEmailName(false)) {
			  	  		jQuery('#chainActButton' + WatuPRO.exam_id).show();
			  	  		jQuery('#chainActButton' + WatuPRO.exam_id).removeAttr('disabled');
			  	  		return false;
			  	  }	
			  	  WatuPRO.forceSubmit = true;
			  	  WatuPRO.submitResult(null);
			  }		 
		});
	} // end goon
	
	// handle the WatuPRO advanced setting for automatically going to next question	
	if(typeof(WatuPROSettings[WatuPRO.exam_id]) !== 'undefined' && WatuPROSettings[WatuPRO.exam_id].singleChoiceAction == 'next') {			
		jQuery('#quiz-' + WatuPRO.exam_id + ' input[type=radio].answer').click(function(e){			
			wchainedLogic.goon(WatuPRO.exam_id);
		}); // end click event
	} // end handling automated going to next question
});